﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace HyperCube.Models
{
    public class SmartContract
    {
        public int ID;
        public string Code;
        public string ByteCode;
        public string Name = "";
        public string Address = "";

        public static SmartContract Find(string name)
        {
            var bc = Blockchain.GetMain();
            if (bc != null)
            {
                var contracts = bc.contractNames;
                if (contracts.ContainsKey(name))
                {
                    return contracts[name];
                }
            }
            return null;            
        }

        public SmartContract()
        { }

        public async Task Run(string weiValue = "0x0")
        {
            var verifierAccount = AccountModel.Current;
            //Console.WriteLine($"Verify {verifierAccount.Name}");

            //if (Blockchain.GetMain().contractNames.ContainsKey("Verify"))
            //{
            //    var contr = Blockchain.GetMain().contractNames["Verify"];
            //    var res = Blockchain.GetMain().RunContractWrite(contr.Address, "0x11111111");
            //    Console.WriteLine("Test verify RUN " + res);
            //}
            //TODO run smart contract with verifier wallet
        }

        public SmartContract(int id, string name, string code, string bytecode)
        {
            ID = id;
            Name = name;
            Code = code;
            ByteCode = bytecode;
        }
    }
}
